
public class ListLinked implements Lista {

	private Puntatore inizioLista = null;
	
	
	public boolean isEmpty() {
		return inizioLista == null;
	}
	
	public Posizione firstList() {
		return null;
		
	}	

	public boolean endList(Posizione p) {
		if (isEmpty()) return true;
		if (p == firstList())
			return inizioLista == null; // verifica che la lista sia vuota
		else
			return ((Puntatore)p).link.successivo == null; //verifica che elemento successivo a quello in posizione p sia nullo
	}


	public Object readList(Posizione p) {
		if (isEmpty())
			throw new IndexOutOfBoundsException("Lista vuota");
		if (p == firstList())
			return inizioLista.link.elemento;
		else
			return ((Puntatore) p).link.successivo.link.elemento;
		
			

	}
	public void insert(Object e, Posizione p) {
		Puntatore temp,q;

		if (!isEmpty()) {
			//se la lista non  vuota
			if (p == firstList()) {
				// se primo lista
				temp = inizioLista;
				inizioLista = new Puntatore(new Cella(e));
				inizioLista.link.successivo = temp;
			} else {
				temp = ((Puntatore) p).link.successivo;
				q = new Puntatore(new Cella(e));
				((Puntatore) p).link.successivo = q;
				q.link.successivo =  temp;
			}
		} else {
			// se la lista  vuota
			inizioLista = new Puntatore(new Cella(e));
		}

	}

	
	public Posizione succ(Posizione p) {
		if (endList(p))
			throw new IndexOutOfBoundsException(
					"Posizione fine lista non valida");
		if (isEmpty())
			throw new IndexOutOfBoundsException("Lista vuota");
		if (p == firstList())
			return inizioLista;			
		else if (p == inizioLista)
			return inizioLista.link.successivo;
		else
			return ((Puntatore) p).link.successivo;
	}

	
	// Per esercizio
	
	
	/*
 	 * se p==firstList() si solleva una IndexOutOfBoundsException
	 * se la lista  vuota si solleva una IndexOutOfBoundsException
	 * altimenti partendo da inizioLista si scandisce la lista fino a trovare 
	 * il puntatore a una Cella (denotato come temp) tale che temp.link.successivo sia uguale a p
 */

	public Posizione pred(Posizione p) {
		//da implementare
	}

/*
 	 * se p==endList() si solleva una IndexOutOfBoundsException
	 * se p == firstList() si sposta inizioLista sull'elemento successivo da esso puntato
	 * altimenti si modifica p in modo che il suo successivo sia quello puntato dal suo successivo corrente
 */

	public void remove(Posizione p) {
		//da implementare
	}

	/*
	 * Se si  alla fine della lista si solleva una IndexOutOfBoundsException
	 * altrimenti si assegna e al campo elemento di ((Puntatore) p).link.successivo
	 */
	public void writeList(Object e, Posizione p) {
		//da implementare
	}

}
